####################################################################
#
#    This file was generated using Parse::Yapp version 1.05.
#
#        Don't edit this file, use source file instead.
#
#             ANY CHANGE MADE HERE WILL BE LOST !
#
####################################################################
package Choicetool::Parse;
use vars qw ( @ISA );
use strict;

@ISA= qw ( Parse::Yapp::Driver );
#Included Parse/Yapp/Driver.pm file----------------------------------------
{
#
# Module Parse::Yapp::Driver
#
# This module is part of the Parse::Yapp package available on your
# nearest CPAN
#
# Any use of this module in a standalone parser make the included
# text under the same copyright as the Parse::Yapp module itself.
#
# This notice should remain unchanged.
#
# (c) Copyright 1998-2001 Francois Desarmenien, all rights reserved.
# (see the pod text in Parse::Yapp module for use and distribution rights)
#

package Parse::Yapp::Driver;

require 5.004;

use strict;

use vars qw ( $VERSION $COMPATIBLE $FILENAME );

$VERSION = '1.05';
$COMPATIBLE = '0.07';
$FILENAME=__FILE__;

use Carp;

#Known parameters, all starting with YY (leading YY will be discarded)
my(%params)=(YYLEX => 'CODE', 'YYERROR' => 'CODE', YYVERSION => '',
			 YYRULES => 'ARRAY', YYSTATES => 'ARRAY', YYDEBUG => '');
#Mandatory parameters
my(@params)=('LEX','RULES','STATES');

sub new {
    my($class)=shift;
	my($errst,$nberr,$token,$value,$check,$dotpos);
    my($self)={ ERROR => \&_Error,
				ERRST => \$errst,
                NBERR => \$nberr,
				TOKEN => \$token,
				VALUE => \$value,
				DOTPOS => \$dotpos,
				STACK => [],
				DEBUG => 0,
				CHECK => \$check };

	_CheckParams( [], \%params, \@_, $self );

		exists($$self{VERSION})
	and	$$self{VERSION} < $COMPATIBLE
	and	croak "Yapp driver version $VERSION ".
			  "incompatible with version $$self{VERSION}:\n".
			  "Please recompile parser module.";

        ref($class)
    and $class=ref($class);

    bless($self,$class);
}

sub YYParse {
    my($self)=shift;
    my($retval);

	_CheckParams( \@params, \%params, \@_, $self );

	if($$self{DEBUG}) {
		_DBLoad();
		$retval = eval '$self->_DBParse()';#Do not create stab entry on compile
        $@ and die $@;
	}
	else {
		$retval = $self->_Parse();
	}
    $retval
}

sub YYData {
	my($self)=shift;

		exists($$self{USER})
	or	$$self{USER}={};

	$$self{USER};
	
}

sub YYErrok {
	my($self)=shift;

	${$$self{ERRST}}=0;
    undef;
}

sub YYNberr {
	my($self)=shift;

	${$$self{NBERR}};
}

sub YYRecovering {
	my($self)=shift;

	${$$self{ERRST}} != 0;
}

sub YYAbort {
	my($self)=shift;

	${$$self{CHECK}}='ABORT';
    undef;
}

sub YYAccept {
	my($self)=shift;

	${$$self{CHECK}}='ACCEPT';
    undef;
}

sub YYError {
	my($self)=shift;

	${$$self{CHECK}}='ERROR';
    undef;
}

sub YYSemval {
	my($self)=shift;
	my($index)= $_[0] - ${$$self{DOTPOS}} - 1;

		$index < 0
	and	-$index <= @{$$self{STACK}}
	and	return $$self{STACK}[$index][1];

	undef;	#Invalid index
}

sub YYCurtok {
	my($self)=shift;

        @_
    and ${$$self{TOKEN}}=$_[0];
    ${$$self{TOKEN}};
}

sub YYCurval {
	my($self)=shift;

        @_
    and ${$$self{VALUE}}=$_[0];
    ${$$self{VALUE}};
}

sub YYExpect {
    my($self)=shift;

    keys %{$self->{STATES}[$self->{STACK}[-1][0]]{ACTIONS}}
}

sub YYLexer {
    my($self)=shift;

	$$self{LEX};
}


#################
# Private stuff #
#################


sub _CheckParams {
	my($mandatory,$checklist,$inarray,$outhash)=@_;
	my($prm,$value);
	my($prmlst)={};

	while(($prm,$value)=splice(@$inarray,0,2)) {
        $prm=uc($prm);
			exists($$checklist{$prm})
		or	croak("Unknow parameter '$prm'");
			ref($value) eq $$checklist{$prm}
		or	croak("Invalid value for parameter '$prm'");
        $prm=unpack('@2A*',$prm);
		$$outhash{$prm}=$value;
	}
	for (@$mandatory) {
			exists($$outhash{$_})
		or	croak("Missing mandatory parameter '".lc($_)."'");
	}
}

sub _Error {
	print "Parse error.\n";
}

sub _DBLoad {
	{
		no strict 'refs';

			exists(${__PACKAGE__.'::'}{_DBParse})#Already loaded ?
		and	return;
	}
	my($fname)=__FILE__;
	my(@drv);
	open(DRV,"<$fname") or die "Report this as a BUG: Cannot open $fname";
	while(<DRV>) {
                	/^\s*sub\s+_Parse\s*{\s*$/ .. /^\s*}\s*#\s*_Parse\s*$/
        	and     do {
                	s/^#DBG>//;
                	push(@drv,$_);
        	}
	}
	close(DRV);

	$drv[0]=~s/_P/_DBP/;
	eval join('',@drv);
}

#Note that for loading debugging version of the driver,
#this file will be parsed from 'sub _Parse' up to '}#_Parse' inclusive.
#So, DO NOT remove comment at end of sub !!!
sub _Parse {
    my($self)=shift;

	my($rules,$states,$lex,$error)
     = @$self{ 'RULES', 'STATES', 'LEX', 'ERROR' };
	my($errstatus,$nberror,$token,$value,$stack,$check,$dotpos)
     = @$self{ 'ERRST', 'NBERR', 'TOKEN', 'VALUE', 'STACK', 'CHECK', 'DOTPOS' };

#DBG>	my($debug)=$$self{DEBUG};
#DBG>	my($dbgerror)=0;

#DBG>	my($ShowCurToken) = sub {
#DBG>		my($tok)='>';
#DBG>		for (split('',$$token)) {
#DBG>			$tok.=		(ord($_) < 32 or ord($_) > 126)
#DBG>					?	sprintf('<%02X>',ord($_))
#DBG>					:	$_;
#DBG>		}
#DBG>		$tok.='<';
#DBG>	};

	$$errstatus=0;
	$$nberror=0;
	($$token,$$value)=(undef,undef);
	@$stack=( [ 0, undef ] );
	$$check='';

    while(1) {
        my($actions,$act,$stateno);

        $stateno=$$stack[-1][0];
        $actions=$$states[$stateno];

#DBG>	print STDERR ('-' x 40),"\n";
#DBG>		$debug & 0x2
#DBG>	and	print STDERR "In state $stateno:\n";
#DBG>		$debug & 0x08
#DBG>	and	print STDERR "Stack:[".
#DBG>					 join(',',map { $$_[0] } @$stack).
#DBG>					 "]\n";


        if  (exists($$actions{ACTIONS})) {

				defined($$token)
            or	do {
				($$token,$$value)=&$lex($self);
#DBG>				$debug & 0x01
#DBG>			and	print STDERR "Need token. Got ".&$ShowCurToken."\n";
			};

            $act=   exists($$actions{ACTIONS}{$$token})
                    ?   $$actions{ACTIONS}{$$token}
                    :   exists($$actions{DEFAULT})
                        ?   $$actions{DEFAULT}
                        :   undef;
        }
        else {
            $act=$$actions{DEFAULT};
#DBG>			$debug & 0x01
#DBG>		and	print STDERR "Don't need token.\n";
        }

            defined($act)
        and do {

                $act > 0
            and do {        #shift

#DBG>				$debug & 0x04
#DBG>			and	print STDERR "Shift and go to state $act.\n";

					$$errstatus
				and	do {
					--$$errstatus;

#DBG>					$debug & 0x10
#DBG>				and	$dbgerror
#DBG>				and	$$errstatus == 0
#DBG>				and	do {
#DBG>					print STDERR "**End of Error recovery.\n";
#DBG>					$dbgerror=0;
#DBG>				};
				};


                push(@$stack,[ $act, $$value ]);

					$$token ne ''	#Don't eat the eof
				and	$$token=$$value=undef;
                next;
            };

            #reduce
            my($lhs,$len,$code,@sempar,$semval);
            ($lhs,$len,$code)=@{$$rules[-$act]};

#DBG>			$debug & 0x04
#DBG>		and	$act
#DBG>		and	print STDERR "Reduce using rule ".-$act." ($lhs,$len): ";

                $act
            or  $self->YYAccept();

            $$dotpos=$len;

                unpack('A1',$lhs) eq '@'    #In line rule
            and do {
                    $lhs =~ /^\@[0-9]+\-([0-9]+)$/
                or  die "In line rule name '$lhs' ill formed: ".
                        "report it as a BUG.\n";
                $$dotpos = $1;
            };

            @sempar =       $$dotpos
                        ?   map { $$_[1] } @$stack[ -$$dotpos .. -1 ]
                        :   ();

            $semval = $code ? &$code( $self, @sempar )
                            : @sempar ? $sempar[0] : undef;

            splice(@$stack,-$len,$len);

                $$check eq 'ACCEPT'
            and do {

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Accept.\n";

				return($semval);
			};

                $$check eq 'ABORT'
            and	do {

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Abort.\n";

				return(undef);

			};

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Back to state $$stack[-1][0], then ";

                $$check eq 'ERROR'
            or  do {
#DBG>				$debug & 0x04
#DBG>			and	print STDERR 
#DBG>				    "go to state $$states[$$stack[-1][0]]{GOTOS}{$lhs}.\n";

#DBG>				$debug & 0x10
#DBG>			and	$dbgerror
#DBG>			and	$$errstatus == 0
#DBG>			and	do {
#DBG>				print STDERR "**End of Error recovery.\n";
#DBG>				$dbgerror=0;
#DBG>			};

			    push(@$stack,
                     [ $$states[$$stack[-1][0]]{GOTOS}{$lhs}, $semval ]);
                $$check='';
                next;
            };

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Forced Error recovery.\n";

            $$check='';

        };

        #Error
            $$errstatus
        or   do {

            $$errstatus = 1;
            &$error($self);
                $$errstatus # if 0, then YYErrok has been called
            or  next;       # so continue parsing

#DBG>			$debug & 0x10
#DBG>		and	do {
#DBG>			print STDERR "**Entering Error recovery.\n";
#DBG>			++$dbgerror;
#DBG>		};

            ++$$nberror;

        };

			$$errstatus == 3	#The next token is not valid: discard it
		and	do {
				$$token eq ''	# End of input: no hope
			and	do {
#DBG>				$debug & 0x10
#DBG>			and	print STDERR "**At eof: aborting.\n";
				return(undef);
			};

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**Dicard invalid token ".&$ShowCurToken.".\n";

			$$token=$$value=undef;
		};

        $$errstatus=3;

		while(	  @$stack
			  and (		not exists($$states[$$stack[-1][0]]{ACTIONS})
			        or  not exists($$states[$$stack[-1][0]]{ACTIONS}{error})
					or	$$states[$$stack[-1][0]]{ACTIONS}{error} <= 0)) {

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**Pop state $$stack[-1][0].\n";

			pop(@$stack);
		}

			@$stack
		or	do {

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**No state left on stack: aborting.\n";

			return(undef);
		};

		#shift the error token

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**Shift \$error token and go to state ".
#DBG>						 $$states[$$stack[-1][0]]{ACTIONS}{error}.
#DBG>						 ".\n";

		push(@$stack, [ $$states[$$stack[-1][0]]{ACTIONS}{error}, undef ]);

    }

    #never reached
	croak("Error in driver logic. Please, report it as a BUG");

}#_Parse
#DO NOT remove comment

1;

}
#End of include--------------------------------------------------


#line 1 "./Parse.yp"

#
# Parse.pm
#
# (C) 2007, 2008 Francesco Salvestrini <salvestrini@users.sourceforge.net>
#                Alessandro Massignan <ff0000.it@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#

use 5.8.0;

use warnings;
use strict;
use diagnostics;

use Choicetool::Autoconfig;
use Choicetool::Base::Trace;
use Choicetool::Base::Debug;

BEGIN {
    use Exporter ();
    our ($VERSION, @ISA, @EXPORT);

    @ISA    = qw(Exporter);
    @EXPORT = qw(&parse);
}

my $parsed_string      = "";
my $help_text_parse    = 0;
my $help_start         = 0;

my $lineno             = 1;
my $max_keyword_length = 10;

my $prompt;
my $symbol;



sub new {
        my($class)=shift;
        ref($class)
    and $class=ref($class);

    my($self)=$class->SUPER::new( yyversion => '1.05',
                                  yystates =>
[
	{#State 0
		DEFAULT => -1,
		GOTOS => {
			'input' => 2,
			'@1-0' => 1
		}
	},
	{#State 1
		DEFAULT => -3,
		GOTOS => {
			'stmt_list' => 3
		}
	},
	{#State 2
		ACTIONS => {
			'' => 4
		}
	},
	{#State 3
		ACTIONS => {
			"T_MAINMENU" => 5,
			"T_COMMENT" => -121,
			"T_ENDMENU" => -82,
			"T_CONFIG" => -22,
			"T_EOL" => -15,
			"T_ENDIF" => 21,
			"T_IF" => -72,
			"T_SOURCE" => -129,
			"T_ENDCHOICE" => 23,
			"T_MENUCONFIG" => -125,
			"T_CHOICE" => -101,
			"T_MENU" => -86
		},
		DEFAULT => -2,
		GOTOS => {
			'@18-0' => 6,
			'@28-0' => 7,
			'comment_stmt' => 9,
			'@15-0' => 8,
			'choice_stmt' => 10,
			'menu_stmt' => 11,
			'@19-0' => 12,
			'if_stmt' => 14,
			'@5-0' => 13,
			'config_stmt' => 16,
			'source_stmt' => 15,
			'menuconfig_stmt' => 17,
			'@23-0' => 18,
			'@32-0' => 19,
			'common_stmt' => 20,
			'end' => 22,
			'@4-0' => 24,
			'@30-0' => 25
		}
	},
	{#State 4
		DEFAULT => 0
	},
	{#State 5
		ACTIONS => {
			"T_WORD_QUOTE" => 26
		},
		DEFAULT => -12,
		GOTOS => {
			'@3-0' => 28,
			'prompt' => 27
		}
	},
	{#State 6
		ACTIONS => {
			"T_ENDMENU" => 29
		}
	},
	{#State 7
		DEFAULT => -123,
		GOTOS => {
			'@29-0' => 30,
			'comment' => 31
		}
	},
	{#State 8
		DEFAULT => -74,
		GOTOS => {
			'if_entry' => 33,
			'@16-0' => 32
		}
	},
	{#State 9
		DEFAULT => -19
	},
	{#State 10
		DEFAULT => -5
	},
	{#State 11
		DEFAULT => -6
	},
	{#State 12
		DEFAULT => -88,
		GOTOS => {
			'menu_entry' => 34,
			'@20-0' => 35
		}
	},
	{#State 13
		DEFAULT => -24,
		GOTOS => {
			'config_entry_start' => 36,
			'@6-0' => 37
		}
	},
	{#State 14
		DEFAULT => -18
	},
	{#State 15
		DEFAULT => -21
	},
	{#State 16
		DEFAULT => -17
	},
	{#State 17
		DEFAULT => -20
	},
	{#State 18
		DEFAULT => -103,
		GOTOS => {
			'@24-0' => 38,
			'choice_entry' => 39
		}
	},
	{#State 19
		ACTIONS => {
			"T_SOURCE" => 40
		}
	},
	{#State 20
		DEFAULT => -4
	},
	{#State 21
		ACTIONS => {
			"T_EOL" => 41
		}
	},
	{#State 22
		DEFAULT => -8
	},
	{#State 23
		ACTIONS => {
			"T_EOL" => 42
		}
	},
	{#State 24
		ACTIONS => {
			"T_EOL" => 43
		}
	},
	{#State 25
		DEFAULT => -127,
		GOTOS => {
			'@31-0' => 45,
			'menuconfig_entry_start' => 44
		}
	},
	{#State 26
		DEFAULT => -14
	},
	{#State 27
		DEFAULT => -9,
		GOTOS => {
			'newlines' => 46,
			'@2-0' => 47
		}
	},
	{#State 28
		ACTIONS => {
			"T_WORD" => 48
		}
	},
	{#State 29
		ACTIONS => {
			"T_EOL" => 49
		}
	},
	{#State 30
		ACTIONS => {
			"T_COMMENT" => 50
		}
	},
	{#State 31
		DEFAULT => -92,
		GOTOS => {
			'depends_list' => 51
		}
	},
	{#State 32
		ACTIONS => {
			"T_IF" => 52
		}
	},
	{#State 33
		DEFAULT => -76,
		GOTOS => {
			'if_block' => 53
		}
	},
	{#State 34
		DEFAULT => -95,
		GOTOS => {
			'menu_block' => 54
		}
	},
	{#State 35
		DEFAULT => -90,
		GOTOS => {
			'@21-0' => 55,
			'menu' => 56
		}
	},
	{#State 36
		DEFAULT => -26,
		GOTOS => {
			'config_option_list' => 57
		}
	},
	{#State 37
		ACTIONS => {
			"T_CONFIG" => 58
		}
	},
	{#State 38
		DEFAULT => -105,
		GOTOS => {
			'@25-0' => 59,
			'choice' => 60
		}
	},
	{#State 39
		DEFAULT => -117,
		GOTOS => {
			'choice_block' => 61
		}
	},
	{#State 40
		ACTIONS => {
			"T_WORD_QUOTE" => 26
		},
		DEFAULT => -12,
		GOTOS => {
			'@3-0' => 28,
			'prompt' => 62
		}
	},
	{#State 41
		DEFAULT => -85
	},
	{#State 42
		DEFAULT => -84
	},
	{#State 43
		DEFAULT => -16
	},
	{#State 44
		DEFAULT => -26,
		GOTOS => {
			'config_option_list' => 63
		}
	},
	{#State 45
		ACTIONS => {
			"T_MENUCONFIG" => 64
		}
	},
	{#State 46
		ACTIONS => {
			"T_EOL" => 65
		},
		DEFAULT => -7
	},
	{#State 47
		ACTIONS => {
			"T_EOL" => 66
		}
	},
	{#State 48
		DEFAULT => -13
	},
	{#State 49
		DEFAULT => -83
	},
	{#State 50
		ACTIONS => {
			"T_WORD_QUOTE" => 26
		},
		DEFAULT => -12,
		GOTOS => {
			'@3-0' => 28,
			'prompt' => 67
		}
	},
	{#State 51
		ACTIONS => {
			"T_EOL" => 68,
			"T_REQUIRES" => 70,
			"T_DEPENDS" => 71
		},
		DEFAULT => -122,
		GOTOS => {
			'depends' => 72,
			'@12-0' => 69
		}
	},
	{#State 52
		ACTIONS => {
			"T_OPEN_PAREN" => 79,
			"T_NOT" => 73,
			"T_WORD_QUOTE" => 78
		},
		DEFAULT => -45,
		GOTOS => {
			'symbol' => 77,
			'expr' => 76,
			'@10-0' => 74,
			'@9-0' => 75
		}
	},
	{#State 53
		ACTIONS => {
			"T_COMMENT" => -121,
			"T_CONFIG" => -22,
			"T_EOL" => -15,
			"T_IF" => -72,
			"T_SOURCE" => -129,
			"T_MENUCONFIG" => -125,
			"T_MENU" => -86,
			"T_CHOICE" => -101
		},
		DEFAULT => -80,
		GOTOS => {
			'@28-0' => 7,
			'comment_stmt' => 9,
			'@15-0' => 8,
			'choice_stmt' => 80,
			'menu_stmt' => 81,
			'@19-0' => 12,
			'if_stmt' => 14,
			'@17-0' => 82,
			'@5-0' => 13,
			'config_stmt' => 16,
			'source_stmt' => 15,
			'if_end' => 83,
			'menuconfig_stmt' => 17,
			'@23-0' => 18,
			'@32-0' => 19,
			'common_stmt' => 84,
			'@4-0' => 24,
			'@30-0' => 25
		}
	},
	{#State 54
		ACTIONS => {
			"T_COMMENT" => -121,
			"T_CONFIG" => -22,
			"T_EOL" => -15,
			"T_IF" => -72,
			"T_SOURCE" => -129,
			"T_MENUCONFIG" => -125,
			"T_CHOICE" => -101,
			"T_MENU" => -86
		},
		DEFAULT => -99,
		GOTOS => {
			'@28-0' => 7,
			'menu_end' => 85,
			'comment_stmt' => 9,
			'@15-0' => 8,
			'choice_stmt' => 86,
			'menu_stmt' => 87,
			'@19-0' => 12,
			'if_stmt' => 14,
			'@5-0' => 13,
			'config_stmt' => 16,
			'source_stmt' => 15,
			'@22-0' => 88,
			'menuconfig_stmt' => 17,
			'@23-0' => 18,
			'@32-0' => 19,
			'common_stmt' => 89,
			'@4-0' => 24,
			'@30-0' => 25
		}
	},
	{#State 55
		ACTIONS => {
			"T_MENU" => 90
		}
	},
	{#State 56
		DEFAULT => -92,
		GOTOS => {
			'depends_list' => 91
		}
	},
	{#State 57
		ACTIONS => {
			"T_HELP" => -68,
			"T_HEX" => -32,
			"T_STRING" => -32,
			"T_EOL" => 94,
			"T_SELECT" => 93,
			"T_INT" => -32,
			"T_BOOL" => -32,
			"T_REQUIRES" => 70,
			"T_PROMPT" => 97,
			"T_TRISTATE" => -32,
			"T_DEPENDS" => 71,
			"T_DEFAULT" => 100,
			"T_OPTION" => -58
		},
		DEFAULT => -23,
		GOTOS => {
			'@11-0' => 98,
			'symbol_option' => 92,
			'@12-0' => 69,
			'config_option' => 99,
			'@13-0' => 95,
			'help' => 96,
			'@7-0' => 101,
			'depends' => 102
		}
	},
	{#State 58
		ACTIONS => {
			"T_WORD" => 103
		}
	},
	{#State 59
		ACTIONS => {
			"T_CHOICE" => 104
		}
	},
	{#State 60
		DEFAULT => -107,
		GOTOS => {
			'choice_option_list' => 105
		}
	},
	{#State 61
		ACTIONS => {
			"T_COMMENT" => -121,
			"T_CONFIG" => -22,
			"T_EOL" => -15,
			"T_IF" => -72,
			"T_SOURCE" => -129,
			"T_MENUCONFIG" => -125
		},
		DEFAULT => -119,
		GOTOS => {
			'menuconfig_stmt' => 17,
			'@27-0' => 107,
			'choice_end' => 106,
			'@28-0' => 7,
			'@32-0' => 19,
			'comment_stmt' => 9,
			'@15-0' => 8,
			'common_stmt' => 108,
			'@5-0' => 13,
			'if_stmt' => 14,
			'@4-0' => 24,
			'@30-0' => 25,
			'source_stmt' => 15,
			'config_stmt' => 16
		}
	},
	{#State 62
		ACTIONS => {
			"T_EOL" => 109
		}
	},
	{#State 63
		ACTIONS => {
			"T_HELP" => -68,
			"T_HEX" => -32,
			"T_STRING" => -32,
			"T_EOL" => 94,
			"T_SELECT" => 93,
			"T_INT" => -32,
			"T_BOOL" => -32,
			"T_REQUIRES" => 70,
			"T_PROMPT" => 97,
			"T_TRISTATE" => -32,
			"T_DEPENDS" => 71,
			"T_DEFAULT" => 100,
			"T_OPTION" => -58
		},
		DEFAULT => -126,
		GOTOS => {
			'@11-0' => 98,
			'symbol_option' => 92,
			'@12-0' => 69,
			'config_option' => 99,
			'@13-0' => 95,
			'help' => 96,
			'@7-0' => 101,
			'depends' => 102
		}
	},
	{#State 64
		ACTIONS => {
			"T_WORD" => 110
		}
	},
	{#State 65
		DEFAULT => -11
	},
	{#State 66
		DEFAULT => -10
	},
	{#State 67
		ACTIONS => {
			"T_EOL" => 111
		}
	},
	{#State 68
		DEFAULT => -94
	},
	{#State 69
		ACTIONS => {
			"T_DEPENDS" => 112
		}
	},
	{#State 70
		ACTIONS => {
			"T_OPEN_PAREN" => 79,
			"T_NOT" => 73,
			"T_WORD_QUOTE" => 78
		},
		DEFAULT => -45,
		GOTOS => {
			'symbol' => 77,
			'expr' => 113,
			'@10-0' => 74,
			'@9-0' => 75
		}
	},
	{#State 71
		ACTIONS => {
			"T_ON" => 114
		}
	},
	{#State 72
		DEFAULT => -93
	},
	{#State 73
		ACTIONS => {
			"T_OPEN_PAREN" => 79,
			"T_NOT" => 73,
			"T_WORD_QUOTE" => 78
		},
		DEFAULT => -45,
		GOTOS => {
			'symbol' => 77,
			'expr' => 115,
			'@10-0' => 74,
			'@9-0' => 75
		}
	},
	{#State 74
		ACTIONS => {
			"T_WORD" => 116
		}
	},
	{#State 75
		ACTIONS => {
			"T_WORD_QUOTE" => 78
		},
		DEFAULT => -53,
		GOTOS => {
			'symbol' => 117,
			'@10-0' => 74
		}
	},
	{#State 76
		ACTIONS => {
			"T_OR" => 118,
			"T_AND" => 119
		},
		DEFAULT => -9,
		GOTOS => {
			'newlines' => 120,
			'@2-0' => 47
		}
	},
	{#State 77
		ACTIONS => {
			"T_EQUAL" => 121,
			"T_UNEQUAL" => 122
		}
	},
	{#State 78
		DEFAULT => -55
	},
	{#State 79
		ACTIONS => {
			"T_OPEN_PAREN" => 79,
			"T_NOT" => 73,
			"T_WORD_QUOTE" => 78
		},
		DEFAULT => -45,
		GOTOS => {
			'symbol' => 77,
			'expr' => 123,
			'@10-0' => 74,
			'@9-0' => 75
		}
	},
	{#State 80
		DEFAULT => -79
	},
	{#State 81
		DEFAULT => -78
	},
	{#State 82
		ACTIONS => {
			"T_ENDCHOICE" => 23,
			"T_ENDIF" => 21
		},
		DEFAULT => -82,
		GOTOS => {
			'@18-0' => 6,
			'end' => 124
		}
	},
	{#State 83
		DEFAULT => -73
	},
	{#State 84
		DEFAULT => -77
	},
	{#State 85
		DEFAULT => -87
	},
	{#State 86
		DEFAULT => -98
	},
	{#State 87
		DEFAULT => -97
	},
	{#State 88
		ACTIONS => {
			"T_ENDCHOICE" => 23,
			"T_ENDIF" => 21
		},
		DEFAULT => -82,
		GOTOS => {
			'@18-0' => 6,
			'end' => 125
		}
	},
	{#State 89
		DEFAULT => -96
	},
	{#State 90
		ACTIONS => {
			"T_WORD_QUOTE" => 26
		},
		DEFAULT => -12,
		GOTOS => {
			'@3-0' => 28,
			'prompt' => 126
		}
	},
	{#State 91
		ACTIONS => {
			"T_DEPENDS" => 71,
			"T_EOL" => 68,
			"T_REQUIRES" => 70
		},
		DEFAULT => -89,
		GOTOS => {
			'depends' => 72,
			'@12-0' => 69
		}
	},
	{#State 92
		DEFAULT => -28
	},
	{#State 93
		ACTIONS => {
			"T_WORD" => 127
		}
	},
	{#State 94
		DEFAULT => -31
	},
	{#State 95
		DEFAULT => -70,
		GOTOS => {
			'help_start' => 128,
			'@14-0' => 129
		}
	},
	{#State 96
		DEFAULT => -30
	},
	{#State 97
		ACTIONS => {
			"T_WORD_QUOTE" => 26
		},
		DEFAULT => -12,
		GOTOS => {
			'@3-0' => 28,
			'prompt' => 130
		}
	},
	{#State 98
		ACTIONS => {
			"T_OPTION" => 131
		}
	},
	{#State 99
		DEFAULT => -27
	},
	{#State 100
		ACTIONS => {
			"T_OPEN_PAREN" => 79,
			"T_NOT" => 73,
			"T_WORD_QUOTE" => 78
		},
		DEFAULT => -45,
		GOTOS => {
			'symbol' => 77,
			'expr' => 132,
			'@10-0' => 74,
			'@9-0' => 75
		}
	},
	{#State 101
		ACTIONS => {
			"T_STRING" => 134,
			"T_HEX" => 133,
			"T_TRISTATE" => 137,
			"T_INT" => 136
		},
		DEFAULT => -37,
		GOTOS => {
			'@8-0' => 138,
			'type_definition' => 135
		}
	},
	{#State 102
		DEFAULT => -29
	},
	{#State 103
		ACTIONS => {
			"T_EOL" => 139
		}
	},
	{#State 104
		ACTIONS => {
			"T_EOL" => 140
		}
	},
	{#State 105
		ACTIONS => {
			"T_HELP" => -68,
			"T_STRING" => 134,
			"T_HEX" => 133,
			"T_OPTIONAL" => 141,
			"T_EOL" => 143,
			"T_INT" => 136,
			"T_BOOL" => -37,
			"T_REQUIRES" => 70,
			"T_PROMPT" => -112,
			"T_TRISTATE" => 137,
			"T_DEPENDS" => 71,
			"T_DEFAULT" => 147
		},
		DEFAULT => -104,
		GOTOS => {
			'@8-0' => 138,
			'type_definition' => 142,
			'@12-0' => 69,
			'choice_option' => 144,
			'@13-0' => 95,
			'@26-0' => 145,
			'help' => 146,
			'depends' => 148
		}
	},
	{#State 106
		DEFAULT => -102
	},
	{#State 107
		ACTIONS => {
			"T_ENDCHOICE" => 23,
			"T_ENDIF" => 21
		},
		DEFAULT => -82,
		GOTOS => {
			'@18-0' => 6,
			'end' => 149
		}
	},
	{#State 108
		DEFAULT => -118
	},
	{#State 109
		DEFAULT => -130
	},
	{#State 110
		ACTIONS => {
			"T_EOL" => 150
		}
	},
	{#State 111
		DEFAULT => -124
	},
	{#State 112
		ACTIONS => {
			"T_OPEN_PAREN" => 79,
			"T_NOT" => 73,
			"T_WORD_QUOTE" => 78
		},
		DEFAULT => -45,
		GOTOS => {
			'symbol' => 77,
			'expr' => 151,
			'@10-0' => 74,
			'@9-0' => 75
		}
	},
	{#State 113
		ACTIONS => {
			"T_OR" => 118,
			"T_AND" => 119,
			"T_EOL" => 152
		}
	},
	{#State 114
		ACTIONS => {
			"T_OPEN_PAREN" => 79,
			"T_NOT" => 73,
			"T_WORD_QUOTE" => 78
		},
		DEFAULT => -45,
		GOTOS => {
			'symbol' => 77,
			'expr' => 153,
			'@10-0' => 74,
			'@9-0' => 75
		}
	},
	{#State 115
		ACTIONS => {
			"T_OR" => 118,
			"T_AND" => 119
		},
		DEFAULT => -50
	},
	{#State 116
		DEFAULT => -54
	},
	{#State 117
		DEFAULT => -46
	},
	{#State 118
		ACTIONS => {
			"T_OPEN_PAREN" => 79,
			"T_NOT" => 73,
			"T_WORD_QUOTE" => 78
		},
		DEFAULT => -45,
		GOTOS => {
			'symbol' => 77,
			'expr' => 154,
			'@10-0' => 74,
			'@9-0' => 75
		}
	},
	{#State 119
		ACTIONS => {
			"T_OPEN_PAREN" => 79,
			"T_NOT" => 73,
			"T_WORD_QUOTE" => 78
		},
		DEFAULT => -45,
		GOTOS => {
			'symbol' => 77,
			'expr' => 155,
			'@10-0' => 74,
			'@9-0' => 75
		}
	},
	{#State 120
		ACTIONS => {
			"T_EOL" => 65
		},
		DEFAULT => -75
	},
	{#State 121
		ACTIONS => {
			"T_WORD_QUOTE" => 78
		},
		DEFAULT => -53,
		GOTOS => {
			'symbol' => 156,
			'@10-0' => 74
		}
	},
	{#State 122
		ACTIONS => {
			"T_WORD_QUOTE" => 78
		},
		DEFAULT => -53,
		GOTOS => {
			'symbol' => 157,
			'@10-0' => 74
		}
	},
	{#State 123
		ACTIONS => {
			"T_OR" => 118,
			"T_CLOSE_PAREN" => 158,
			"T_AND" => 119
		}
	},
	{#State 124
		DEFAULT => -81
	},
	{#State 125
		DEFAULT => -100
	},
	{#State 126
		ACTIONS => {
			"T_EOL" => 159
		}
	},
	{#State 127
		ACTIONS => {
			"T_IF" => 160
		},
		DEFAULT => -56,
		GOTOS => {
			'if_expr' => 161
		}
	},
	{#State 128
		ACTIONS => {
			"T_HELPTEXT" => 162
		}
	},
	{#State 129
		ACTIONS => {
			"T_HELP" => 163
		}
	},
	{#State 130
		ACTIONS => {
			"T_IF" => 160
		},
		DEFAULT => -56,
		GOTOS => {
			'if_expr' => 164
		}
	},
	{#State 131
		DEFAULT => -60,
		GOTOS => {
			'symbol_option_list' => 165
		}
	},
	{#State 132
		ACTIONS => {
			"T_OR" => 118,
			"T_IF" => 160,
			"T_AND" => 119
		},
		DEFAULT => -56,
		GOTOS => {
			'if_expr' => 166
		}
	},
	{#State 133
		DEFAULT => -41
	},
	{#State 134
		DEFAULT => -40
	},
	{#State 135
		ACTIONS => {
			"T_EOL" => -43,
			"T_WORD_QUOTE" => 26
		},
		DEFAULT => -12,
		GOTOS => {
			'@3-0' => 28,
			'prompt_stmt_opt' => 168,
			'prompt' => 167
		}
	},
	{#State 136
		DEFAULT => -42
	},
	{#State 137
		DEFAULT => -39
	},
	{#State 138
		ACTIONS => {
			"T_BOOL" => 169
		}
	},
	{#State 139
		DEFAULT => -25
	},
	{#State 140
		DEFAULT => -106
	},
	{#State 141
		ACTIONS => {
			"T_EOL" => 170
		}
	},
	{#State 142
		ACTIONS => {
			"T_EOL" => -43,
			"T_WORD_QUOTE" => 26
		},
		DEFAULT => -12,
		GOTOS => {
			'@3-0' => 28,
			'prompt_stmt_opt' => 171,
			'prompt' => 167
		}
	},
	{#State 143
		DEFAULT => -111
	},
	{#State 144
		DEFAULT => -108
	},
	{#State 145
		ACTIONS => {
			"T_PROMPT" => 172
		}
	},
	{#State 146
		DEFAULT => -110
	},
	{#State 147
		ACTIONS => {
			"T_WORD" => 173
		}
	},
	{#State 148
		DEFAULT => -109
	},
	{#State 149
		DEFAULT => -120
	},
	{#State 150
		DEFAULT => -128
	},
	{#State 151
		ACTIONS => {
			"T_OR" => 118,
			"T_AND" => 119,
			"T_EOL" => 174
		}
	},
	{#State 152
		DEFAULT => -67
	},
	{#State 153
		ACTIONS => {
			"T_OR" => 118,
			"T_AND" => 119,
			"T_EOL" => 175
		}
	},
	{#State 154
		ACTIONS => {
			"T_OR" => 118,
			"T_AND" => 119
		},
		DEFAULT => -51
	},
	{#State 155
		ACTIONS => {
			"T_OR" => 118,
			"T_AND" => 119
		},
		DEFAULT => -52
	},
	{#State 156
		DEFAULT => -47
	},
	{#State 157
		DEFAULT => -48
	},
	{#State 158
		DEFAULT => -49
	},
	{#State 159
		DEFAULT => -91
	},
	{#State 160
		ACTIONS => {
			"T_OPEN_PAREN" => 79,
			"T_NOT" => 73,
			"T_WORD_QUOTE" => 78
		},
		DEFAULT => -45,
		GOTOS => {
			'symbol' => 77,
			'expr' => 176,
			'@10-0' => 74,
			'@9-0' => 75
		}
	},
	{#State 161
		ACTIONS => {
			"T_EOL" => 177
		}
	},
	{#State 162
		DEFAULT => -69
	},
	{#State 163
		ACTIONS => {
			"T_EOL" => 178
		}
	},
	{#State 164
		ACTIONS => {
			"T_EOL" => 179
		}
	},
	{#State 165
		ACTIONS => {
			"T_EOL" => 180,
			"T_WORD" => 181
		}
	},
	{#State 166
		ACTIONS => {
			"T_EOL" => 182
		}
	},
	{#State 167
		ACTIONS => {
			"T_IF" => 160
		},
		DEFAULT => -56,
		GOTOS => {
			'if_expr' => 183
		}
	},
	{#State 168
		ACTIONS => {
			"T_EOL" => 184
		}
	},
	{#State 169
		DEFAULT => -38
	},
	{#State 170
		DEFAULT => -115
	},
	{#State 171
		ACTIONS => {
			"T_EOL" => 185
		}
	},
	{#State 172
		ACTIONS => {
			"T_WORD_QUOTE" => 26
		},
		DEFAULT => -12,
		GOTOS => {
			'@3-0' => 28,
			'prompt' => 186
		}
	},
	{#State 173
		ACTIONS => {
			"T_IF" => 160
		},
		DEFAULT => -56,
		GOTOS => {
			'if_expr' => 187
		}
	},
	{#State 174
		DEFAULT => -65
	},
	{#State 175
		DEFAULT => -66
	},
	{#State 176
		ACTIONS => {
			"T_OR" => 118,
			"T_AND" => 119
		},
		DEFAULT => -57
	},
	{#State 177
		DEFAULT => -36
	},
	{#State 178
		DEFAULT => -71
	},
	{#State 179
		DEFAULT => -34
	},
	{#State 180
		DEFAULT => -59
	},
	{#State 181
		ACTIONS => {
			"T_EQUAL" => 188
		},
		DEFAULT => -62,
		GOTOS => {
			'symbol_option_arg' => 189
		}
	},
	{#State 182
		DEFAULT => -35
	},
	{#State 183
		DEFAULT => -44
	},
	{#State 184
		DEFAULT => -33
	},
	{#State 185
		DEFAULT => -114
	},
	{#State 186
		ACTIONS => {
			"T_IF" => 160
		},
		DEFAULT => -56,
		GOTOS => {
			'if_expr' => 190
		}
	},
	{#State 187
		ACTIONS => {
			"T_EOL" => 191
		}
	},
	{#State 188
		ACTIONS => {
			"T_WORD_QUOTE" => 26
		},
		DEFAULT => -12,
		GOTOS => {
			'@3-0' => 28,
			'prompt' => 192
		}
	},
	{#State 189
		DEFAULT => -61
	},
	{#State 190
		ACTIONS => {
			"T_EOL" => 193
		}
	},
	{#State 191
		DEFAULT => -116
	},
	{#State 192
		DEFAULT => -63
	},
	{#State 193
		DEFAULT => -113
	}
],
                                  yyrules  =>
[
	[#Rule 0
		 '$start', 2, undef
	],
	[#Rule 1
		 '@1-0', 0,
sub
#line 58 "./Parse.yp"
{
    debug("Entering rule: input");
}
	],
	[#Rule 2
		 'input', 2, undef
	],
	[#Rule 3
		 'stmt_list', 0,
sub
#line 65 "./Parse.yp"
{
    debug("Entering rule: stmt_list");
}
	],
	[#Rule 4
		 'stmt_list', 2, undef
	],
	[#Rule 5
		 'stmt_list', 2, undef
	],
	[#Rule 6
		 'stmt_list', 2, undef
	],
	[#Rule 7
		 'stmt_list', 4, undef
	],
	[#Rule 8
		 'stmt_list', 2, undef
	],
	[#Rule 9
		 '@2-0', 0,
sub
#line 76 "./Parse.yp"
{
    debug("Entering rule: newlines");
}
	],
	[#Rule 10
		 'newlines', 2, undef
	],
	[#Rule 11
		 'newlines', 2, undef
	],
	[#Rule 12
		 '@3-0', 0,
sub
#line 84 "./Parse.yp"
{
    debug("Entering rule: prompt");
}
	],
	[#Rule 13
		 'prompt', 2,
sub
#line 88 "./Parse.yp"
{
    assert(defined($_[1]));

    $prompt = $_[1];
}
	],
	[#Rule 14
		 'prompt', 1,
sub
#line 94 "./Parse.yp"
{
    assert(defined($_[1]));

    $prompt = $_[1];
}
	],
	[#Rule 15
		 '@4-0', 0,
sub
#line 102 "./Parse.yp"
{
    debug("Entering rule: common_stmt");
}
	],
	[#Rule 16
		 'common_stmt', 2, undef
	],
	[#Rule 17
		 'common_stmt', 1, undef
	],
	[#Rule 18
		 'common_stmt', 1, undef
	],
	[#Rule 19
		 'common_stmt', 1, undef
	],
	[#Rule 20
		 'common_stmt', 1, undef
	],
	[#Rule 21
		 'common_stmt', 1, undef
	],
	[#Rule 22
		 '@5-0', 0,
sub
#line 114 "./Parse.yp"
{
    debug("Entering rule: config_stmt");
}
	],
	[#Rule 23
		 'config_stmt', 3, undef
	],
	[#Rule 24
		 '@6-0', 0,
sub
#line 121 "./Parse.yp"
{
    debug("Entering rule: config_entry_start");
}
	],
	[#Rule 25
		 'config_entry_start', 4, undef
	],
	[#Rule 26
		 'config_option_list', 0,
sub
#line 128 "./Parse.yp"
{
    debug("Entering rule: config_option_list");
}
	],
	[#Rule 27
		 'config_option_list', 2, undef
	],
	[#Rule 28
		 'config_option_list', 2, undef
	],
	[#Rule 29
		 'config_option_list', 2, undef
	],
	[#Rule 30
		 'config_option_list', 2, undef
	],
	[#Rule 31
		 'config_option_list', 2, undef
	],
	[#Rule 32
		 '@7-0', 0,
sub
#line 139 "./Parse.yp"
{
    debug("Entering rule: config_option");
}
	],
	[#Rule 33
		 'config_option', 4, undef
	],
	[#Rule 34
		 'config_option', 4, undef
	],
	[#Rule 35
		 'config_option', 4, undef
	],
	[#Rule 36
		 'config_option', 4, undef
	],
	[#Rule 37
		 '@8-0', 0,
sub
#line 149 "./Parse.yp"
{
    debug("Entering rule: type_definition");
}
	],
	[#Rule 38
		 'type_definition', 2, undef
	],
	[#Rule 39
		 'type_definition', 1, undef
	],
	[#Rule 40
		 'type_definition', 1, undef
	],
	[#Rule 41
		 'type_definition', 1, undef
	],
	[#Rule 42
		 'type_definition', 1, undef
	],
	[#Rule 43
		 'prompt_stmt_opt', 0,
sub
#line 160 "./Parse.yp"
{
    debug("Entering rule: prompt_stmt_opt");
}
	],
	[#Rule 44
		 'prompt_stmt_opt', 2, undef
	],
	[#Rule 45
		 '@9-0', 0,
sub
#line 167 "./Parse.yp"
{
    debug("Entering rule: expr");
}
	],
	[#Rule 46
		 'expr', 2, undef
	],
	[#Rule 47
		 'expr', 3, undef
	],
	[#Rule 48
		 'expr', 3, undef
	],
	[#Rule 49
		 'expr', 3, undef
	],
	[#Rule 50
		 'expr', 2, undef
	],
	[#Rule 51
		 'expr', 3, undef
	],
	[#Rule 52
		 'expr', 3, undef
	],
	[#Rule 53
		 '@10-0', 0,
sub
#line 180 "./Parse.yp"
{
    debug("Entering rule: symbol");
}
	],
	[#Rule 54
		 'symbol', 2,
sub
#line 184 "./Parse.yp"
{
    assert(defined($_[1]));

    $symbol = $_[1];
}
	],
	[#Rule 55
		 'symbol', 1,
sub
#line 190 "./Parse.yp"
{
    assert(defined($_[1]));

    $symbol = $_[1];
}
	],
	[#Rule 56
		 'if_expr', 0,
sub
#line 198 "./Parse.yp"
{
    debug("Entering rule: if_expr");
}
	],
	[#Rule 57
		 'if_expr', 2, undef
	],
	[#Rule 58
		 '@11-0', 0,
sub
#line 205 "./Parse.yp"
{
    debug("Entering rule: symbol_option");
}
	],
	[#Rule 59
		 'symbol_option', 4, undef
	],
	[#Rule 60
		 'symbol_option_list', 0,
sub
#line 212 "./Parse.yp"
{
    debug("Entering rule: symbol_option_list");
}
	],
	[#Rule 61
		 'symbol_option_list', 3, undef
	],
	[#Rule 62
		 'symbol_option_arg', 0,
sub
#line 220 "./Parse.yp"
{
    debug("Entering rule: config_option_arg");
}
	],
	[#Rule 63
		 'symbol_option_arg', 2, undef
	],
	[#Rule 64
		 '@12-0', 0,
sub
#line 228 "./Parse.yp"
{
    debug("Entering rule: depends");
}
	],
	[#Rule 65
		 'depends', 4, undef
	],
	[#Rule 66
		 'depends', 4, undef
	],
	[#Rule 67
		 'depends', 3, undef
	],
	[#Rule 68
		 '@13-0', 0,
sub
#line 237 "./Parse.yp"
{
    debug("Entering rule: help");
}
	],
	[#Rule 69
		 'help', 3, undef
	],
	[#Rule 70
		 '@14-0', 0,
sub
#line 244 "./Parse.yp"
{
    debug("Entering rule: help_start");
}
	],
	[#Rule 71
		 'help_start', 3, undef
	],
	[#Rule 72
		 '@15-0', 0,
sub
#line 251 "./Parse.yp"
{
    debug("Entering rule: if_stmt");
}
	],
	[#Rule 73
		 'if_stmt', 4, undef
	],
	[#Rule 74
		 '@16-0', 0,
sub
#line 258 "./Parse.yp"
{
    debug("Entering rule: if_entry");
}
	],
	[#Rule 75
		 'if_entry', 4, undef
	],
	[#Rule 76
		 'if_block', 0,
sub
#line 265 "./Parse.yp"
{
    debug("Entering rule: if_block");
}
	],
	[#Rule 77
		 'if_block', 2, undef
	],
	[#Rule 78
		 'if_block', 2, undef
	],
	[#Rule 79
		 'if_block', 2, undef
	],
	[#Rule 80
		 '@17-0', 0,
sub
#line 275 "./Parse.yp"
{
    debug("Entering rule: if_end");
}
	],
	[#Rule 81
		 'if_end', 2, undef
	],
	[#Rule 82
		 '@18-0', 0,
sub
#line 282 "./Parse.yp"
{
    debug("Entering rule: end");
}
	],
	[#Rule 83
		 'end', 3, undef
	],
	[#Rule 84
		 'end', 2, undef
	],
	[#Rule 85
		 'end', 2, undef
	],
	[#Rule 86
		 '@19-0', 0,
sub
#line 291 "./Parse.yp"
{
    debug("Entering rule: menu_stmt");
}
	],
	[#Rule 87
		 'menu_stmt', 4, undef
	],
	[#Rule 88
		 '@20-0', 0,
sub
#line 298 "./Parse.yp"
{
    debug("Entering rule: menu_entry");
}
	],
	[#Rule 89
		 'menu_entry', 3, undef
	],
	[#Rule 90
		 '@21-0', 0,
sub
#line 305 "./Parse.yp"
{
    debug("Entering rule: menu");
}
	],
	[#Rule 91
		 'menu', 4, undef
	],
	[#Rule 92
		 'depends_list', 0,
sub
#line 312 "./Parse.yp"
{
    debug("Entering rule: depends_list");
}
	],
	[#Rule 93
		 'depends_list', 2, undef
	],
	[#Rule 94
		 'depends_list', 2, undef
	],
	[#Rule 95
		 'menu_block', 0,
sub
#line 320 "./Parse.yp"
{
    debug("Entering rule: menu_block");
}
	],
	[#Rule 96
		 'menu_block', 2, undef
	],
	[#Rule 97
		 'menu_block', 2, undef
	],
	[#Rule 98
		 'menu_block', 2, undef
	],
	[#Rule 99
		 '@22-0', 0,
sub
#line 330 "./Parse.yp"
{
    debug("Entering rule: menu_end");
}
	],
	[#Rule 100
		 'menu_end', 2, undef
	],
	[#Rule 101
		 '@23-0', 0,
sub
#line 337 "./Parse.yp"
{
    debug("Entering rule: choice_stmt");
}
	],
	[#Rule 102
		 'choice_stmt', 4, undef
	],
	[#Rule 103
		 '@24-0', 0,
sub
#line 344 "./Parse.yp"
{
    debug("Entering rule: choice_entry");
}
	],
	[#Rule 104
		 'choice_entry', 3, undef
	],
	[#Rule 105
		 '@25-0', 0,
sub
#line 351 "./Parse.yp"
{
    debug("Entering rule: choice");
}
	],
	[#Rule 106
		 'choice', 3, undef
	],
	[#Rule 107
		 'choice_option_list', 0,
sub
#line 358 "./Parse.yp"
{
    debug("Entering rule: choice_option_list");
}
	],
	[#Rule 108
		 'choice_option_list', 2, undef
	],
	[#Rule 109
		 'choice_option_list', 2, undef
	],
	[#Rule 110
		 'choice_option_list', 2, undef
	],
	[#Rule 111
		 'choice_option_list', 2, undef
	],
	[#Rule 112
		 '@26-0', 0,
sub
#line 369 "./Parse.yp"
{
    debug("Entering rule: choice_option");
}
	],
	[#Rule 113
		 'choice_option', 5, undef
	],
	[#Rule 114
		 'choice_option', 3, undef
	],
	[#Rule 115
		 'choice_option', 2, undef
	],
	[#Rule 116
		 'choice_option', 4, undef
	],
	[#Rule 117
		 'choice_block', 0,
sub
#line 379 "./Parse.yp"
{
    debug("Entering rule: choice_block");
}
	],
	[#Rule 118
		 'choice_block', 2, undef
	],
	[#Rule 119
		 '@27-0', 0,
sub
#line 387 "./Parse.yp"
{
    debug("Entering rule: choice_end");
}
	],
	[#Rule 120
		 'choice_end', 2, undef
	],
	[#Rule 121
		 '@28-0', 0,
sub
#line 394 "./Parse.yp"
{
    debug("Entering rule: comment_stmt");
}
	],
	[#Rule 122
		 'comment_stmt', 3, undef
	],
	[#Rule 123
		 '@29-0', 0,
sub
#line 401 "./Parse.yp"
{
    debug("Entering rule: comment");
}
	],
	[#Rule 124
		 'comment', 4, undef
	],
	[#Rule 125
		 '@30-0', 0,
sub
#line 408 "./Parse.yp"
{
    debug("Entering rule: menuconfig_stmt");
}
	],
	[#Rule 126
		 'menuconfig_stmt', 3, undef
	],
	[#Rule 127
		 '@31-0', 0,
sub
#line 415 "./Parse.yp"
{
    debug("Entering rule: menuconfig_entry_start");
}
	],
	[#Rule 128
		 'menuconfig_entry_start', 4, undef
	],
	[#Rule 129
		 '@32-0', 0,
sub
#line 422 "./Parse.yp"
{
    debug("Entering rule: source_stmt");
}
	],
	[#Rule 130
		 'source_stmt', 4,
sub
#line 426 "./Parse.yp"
{
    my $filename   = $prompt;
    my $string_ref = "";

    assert(defined($filename));

    debug("Including file `" . $filename . "\'");

    if (!source_file($filename, \$string_ref)) {
	exit 1;
    }
}
	]
],
                                  @_);
    bless($self,$class);
}

#line 441 "./Parse.yp"


sub source_file($$)
{
    my $input_file = shift;
    my $reference  = shift;

    if (!&parse($input_file, $reference)) {
	exit 1;
    }

    return 1;
}

sub parse_help($$)
{
    my $stream_ref  = shift;
    my $string_ref  = shift;
    my $root_tab_no = 0;
    my $root_ws     = "";

    assert(defined($$stream_ref));
    assert(defined($$string_ref));

    while ($$stream_ref =~ s/^([^\n]*)\n//) {
	my $string = $1;

	$lineno++;

	if ($string =~ s/^([ \t]+)(.*)$//) {

	    my $curr_ws     = $1;
	    my $curr_line   = $2;
	    my $curr_tab_no = 0;
	    
	    my $tmp = $curr_ws;

	    for (my $i = 0; $i < length($tmp); $i++) {
		my $token = substr($tmp, 0, 1, "");
		
		if ($token =~ /\ /) {
		    $curr_tab_no++;
		} elsif ($token =~ /\t/) {
		    $curr_tab_no += 8;
		}
	    }
	    
	    if (($root_tab_no == 0) &&
		($root_ws eq ""))    {
		$root_tab_no = $curr_tab_no;
		$root_ws     = $curr_ws;
	    }
	    
	    if ($curr_tab_no > $root_tab_no) {
		$curr_ws     = s/^$root_ws//;
		$$string_ref = $$string_ref . $curr_ws . $curr_line . "\n";
	    } elsif ($curr_tab_no == $root_tab_no) {
		$$string_ref = $$string_ref . $curr_line . "\n";
	    } else {
		$$stream_ref = $curr_ws . $curr_line . "\n" . $$stream_ref;
		$lineno--;
		last;
	    }
	} elsif ($string =~ s/^[ \t]*$//) {
	    $$string_ref = $$string_ref . "\n";

	} elsif ($string =~ s/^([^ \t])(.*)$//) {

	    if (defined($2)) {
		$$stream_ref = $2 . "\n" . $$stream_ref;
		$$stream_ref = $1 . $$stream_ref;
	    } else {
		$$stream_ref = $1 . "\n". $$stream_ref;
	    }

	    $lineno--;
	    last;
	} else {
	    bug("Unreachable!");
	}
    }

    return 1;
}

sub lexer_callback {
    my $parser     = shift;
    my $help_text  = "";
    my $buffer     = "";

    assert(defined($parser));

    if ((!defined($parser->YYData->{INPUT})) ||
	($parser->YYData->{INPUT} eq "")) {
	return ('', undef);
    }

    if ($help_text_parse == 1) {

	if (!parse_help(\$parser->YYData->{INPUT}, \$help_text)) {
	    error("Failed to parse help text");
	    exit 1;
	}

	$help_text_parse = 0;
	$help_start      = 0;

	debug("Found token: T_HELPTEXT");
	debug("  Passing string: `" . $help_text . "\'");

	return ('T_HELPTEXT', $help_text);
    }

    while ($parser->YYData->{INPUT} ne "") {

	my $char;

	($char) = $parser->YYData->{INPUT} =~ /^(.)/;

	if (defined($char)              && 
	    ($char =~ /[\&\|\!\=\(\)]/)) {

	    if ($buffer ne "") {
		$parser->YYData->{INPUT} = " " . $parser->YYData->{INPUT};
		next;
	    }
	}

	if ($parser->YYData->{INPUT} =~ s/^\&\&//) {
	    debug("Found token: T_AND");
	    return ('T_AND', '');

	} elsif ($parser->YYData->{INPUT} =~ s/^\|\|//) {
	    debug("Found token: T_OR");
	    return ('T_OR', '');

	} elsif ($parser->YYData->{INPUT} =~ s/^\!\=//) {
	    debug("Found token: T_UNEQUAL");
	    return ('T_UNEQUAL', '');

	} elsif ($parser->YYData->{INPUT} =~ s/^\!//) {
	    debug("Found token: T_NOT");
	    return ('T_NOT', '');

	} elsif ($parser->YYData->{INPUT} =~ s/^\=//) {
	    debug("Found token: T_EQUAL");
	    return ('T_EQUAL', '');

	} elsif ($parser->YYData->{INPUT} =~ s/^\)//) {
	    debug("Found token: T_CLOSE_PAREN");
	    return ('T_CLOSE_PAREN', '');

	} elsif ($parser->YYData->{INPUT} =~ s/^\(//) {
	    debug("Found token: T_OPEN_PAREN");
	    return ('T_OPEN_PAREN', '');

	} else {

	}

	$char = substr($parser->YYData->{INPUT}, 0, 1, "");

	if ($char eq "\n") {

	    if ($buffer ne "") {
		$parser->YYData->{INPUT} = $char . $parser->YYData->{INPUT};

	    } else {
		debug("Found token: T_EOL");

		if ($help_start == 1) {
		    $help_text_parse = 1;
		} else {
		    # Remove useless white spaces
		    $parser->YYData->{INPUT} =~ s/^[ \t]*//;
		}

		$lineno++;

		return ('T_EOL', '');
	    }
	}

	if ($char eq "#") {
	    # Handling comments

	    $parser->YYData->{INPUT} =~ s/^[^\n]*//;
	    next;
	}

	if ($char =~ /\"/) {
	    my $curr_char;
	    my $last_char;

	    $buffer = "";

	    while ($parser->YYData->{INPUT} ne "") {
		$curr_char = substr($parser->YYData->{INPUT}, 0, 1, "");

		if (length($buffer) >= 2) {
		    $buffer    =~ /(.)$/;
		    $last_char = $1;
		}

		if (($curr_char =~ /\"/) &&
		    ($last_char !~ /\\/)) {

		    debug("Found token: T_WORD_QUOTE");
		    debug("  Passing string: `" . $buffer . "\'");

		    return ('T_WORD_QUOTE', $buffer);
		}

		if ($curr_char =~ /\n/) {
		    error("Multiline quoted strings are not supported");
		    return 0;
		}

		if (defined($buffer)) {
		    $buffer = $buffer . $curr_char;
		} else {
		    $buffer = $curr_char;
		}
	    }
	}

	if ($char =~ /[ \t\n]+/) {

	    if ($help_text_parse == 0) {
		# Remove useless white spaces
		$parser->YYData->{INPUT} =~ s/^[ \t]*//;
	    }

	    if ($buffer eq "") {
		next;
	    }

	    if ($buffer eq "menuconfig") {
		debug("Found token: T_MENUCONFIG");
		return ('T_MENUCONFIG', '');

	    } elsif ($buffer eq "endchoice") {
		debug("Found token: T_ENDCHOICE");
		return ('T_ENDCHOICE', '');

	    } elsif ($buffer eq "mainmenu") {	
		debug("Found token: T_MAINMENU");
		return ('T_MAINMENU', '');

	    } elsif ($buffer eq "requires") {
		debug("Found token: T_REQUIRES");
		return ('T_REQUIRES', '');

	    } elsif ($buffer eq "optional") {
		debug("Found token: T_OPTIONAL");
		return ('T_OPTIONAL', '');

	    } elsif ($buffer eq "tristate") {
		debug("Found token: T_TRISTATE");
		return ('T_TRISTATE', '');

	    } elsif ($buffer eq "endmenu") {	
		debug("Found token: T_ENDMENU");
		return ('T_ENDMENU', '');

	    } elsif ($buffer eq "comment") {
		debug("Found token: T_COMMENT");
		return ('T_COMMENT', '');

	    } elsif ($buffer eq "depends") {
		debug("Found token: T_DEPENDS");
		return ('T_DEPENDS', '');

	    } elsif ($buffer eq "default") {
		debug("Found token: T_DEFAULT");
		return ('T_DEFAULT', '');

	    } elsif ($buffer eq "select") {
		debug("Found token: T_SELECT");
		return ('T_SELECT', '');

	    } elsif ($buffer eq "config") {	
		debug("Found token: T_CONFIG");
		return ('T_CONFIG', '');

	    } elsif ($buffer =~ "choice") {
		debug("Found token: T_CHOICE");
		return ('T_CHOICE', '');

	    } elsif ($buffer eq "option") {
		debug("Found token: T_OPTION");
		return ('T_OPTION', '');

	    } elsif ($buffer eq "source") {	
		debug("Found token: T_SOURCE");
		return ('T_SOURCE', '');

	    } elsif ($buffer eq "prompt") {
		debug("Found token: T_PROMPT");
		return ('T_PROMPT', '');

	    } elsif ($buffer eq "endif") {
		debug("Found token: T_ENDIF");
		return ('T_ENDIF', '');

	    } elsif ($buffer eq "range") {
		debug("Found token: T_RANGE");
		return ('T_RANGE', '');

	    } elsif ($buffer eq "menu") {	
		debug("Found token: T_MENU");
		return ('T_MENU', '');

	    } elsif (($buffer eq "help")             ||
		     ($buffer eq "\-\-\-help\-\-\-")) {
		debug("Found token: T_HELP");

		$help_start = 1;
		return ('T_HELP', '');

	    } elsif ($buffer eq "bool") {
		debug("Found token: T_BOOL");
		return ('T_BOOL', '');

	    } elsif ($buffer eq "hex") {
		debug("Found token: T_HEX");
		return ('T_HEX', '');

	    } elsif ($buffer eq "int") {
		debug("Found token: T_INT");
		return ('T_INT', '');

	    } elsif ($buffer eq "if") {
		debug("Found token: T_IF");
		return ('T_IF', '');

	    } elsif ($buffer eq "on") {
		debug("Found token: T_ON");
		return ('T_ON', '');

	    } elsif ($buffer =~ /^([a-zA-Z][a-zA-Z0-9_]*)$/) {
		debug("Found token: T_WORD");
		debug("  Passing string: `" . $buffer . "\'");
		
		return ('T_WORD', $buffer);
	    } else {
		bug("Undefined lexer input at line" . $lineno);
	    }
	}

	if (defined($buffer)) {
	    $buffer = $buffer . $char;
	} else {
	    $buffer = $char;
	}
    }

    bug("Unreacheable lexer code");
}

sub syntax_error {
    my $message = shift;
    my $lineno  = shift;

    assert(defined($message));
    assert(defined($lineno));

    error("Syntax error at line " . $lineno . ": " . $message);
    exit 1;
}

sub error_callback {
    my $parser = shift;

    assert(defined($parser));

    my $value = $parser->YYCurtok;
    assert(defined($value));

    error("Unexpected \`" . $value . "'");
}

sub parse ($$)
{
    my $input_filename = shift;
    my $string_ref     = shift;

    debug("Parsing file \`" . $input_filename . "'");

    if (! -e $input_filename) {
	error("Input file \`" . $input_filename . "' is missing");
	return 0;
    }

    if (! -f $input_filename) {
        error("Cannot open file `" .
              $input_filename      . 
	      "\' "                .
              "for input, it is missing");
        return 0;
    }

    my $filehandle;

    if (!open($filehandle, "<", $input_filename)) {
        error("Cannot open `" . $input_filename . "\' for input");
        return 0;
    }

    my $string;

    $string = "";

    while (<$filehandle>) {
        $string = $string . $_;
    }

    close($filehandle);

    # Parse !
    my $parser;
    $parser = Choicetool::Parse->new();
    assert(defined($parser));

    $parser->YYData->{INPUT} = $string;

    my $result;
    $result = $parser->YYParse(yylex   => \&lexer_callback,
			       yyerror => \&error_callback);
    
    if ($parser->YYNberr() > 0) {
	error("Cannot parse input file \`" . $input_filename . "'");
	return 0;
    }
    
    debug("Parsing completed successfully");

    ${$string_ref} = $parsed_string;
    
    return 1;
}

1;
